unit PrimUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

const
 maxn=4;
 ratio=200;

type
 TPoint=record
  X:real;
  Y:real;
  Z:real;
  I:real;
  phaze:real
 end;
 TPointMatrix=array[1..maxn] of TPoint;
 TIntensityMatrix=array[-ratio..ratio,-ratio..ratio] of real;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

const
 c1:real=1;
 L02:real=0;
var
  Form1: TForm1;
  A:TPointMatrix;
  Int:TIntensityMatrix;
  Scale:real;

procedure Evaluate;
procedure Draw;
procedure InitData;

implementation

{$R *.dfm}
procedure InitData;
var
 ix,iy:integer;
 j:word;
begin
 Scale:=10;
 for j:=1 to maxn do
  with A[j] do
  begin
   X:=0;
   Y:=0;
   Z:=50*j;
   I:=1;
   phaze:=0;
  end;
end;

procedure Evaluate;
var
 ix,iy:integer;
 x0,y0:real;
 S:real;
 LI,LJ:real;
 II,IJ:real;
 FiI,FiJ:real;
 k:real;
 i,j:word;
begin
 Form1.Button1.Caption:='Wait...';
 k:=2*pi/20;
 for iy:=-ratio to ratio do
  for ix:=-ratio to ratio do
  begin
   x0:=scale*ix; y0:=scale*iy;
   S:=0;
   for i:=1 to maxn do
    for j:=1 to maxn do
    begin
     with A[i] do
      LI:=(x-x0)*(x-x0)+(y-y0)*(y-y0)+z*z;
     with A[j] do
      LJ:=(x-x0)*(x-x0)+(y-y0)*(y-y0)+z*z;
     LI:=sqrt(LI);
     LJ:=sqrt(LJ);
     II:=A[i].I{/LI};
     IJ:=A[j].I{/LJ};
     FiI:=k*LI+A[i].phaze;
     FiJ:=k*LJ+A[j].phaze;
     S:=S + II*IJ*cos(FiI-FiJ);
    end;
   Int[ix,iy]:=S;
  end;
 Form1.Button1.Caption:='Done!';
end;

procedure Draw;
var
 ix,iy:integer;
 grx,gry:integer;
 IMax:real;
 cI:real;
 c:byte;
 Col:TColor;
 j:word;
begin
 IMax:=0;
 for iy:=-ratio to ratio do
  for ix:=-ratio to ratio do
   if Int[ix,iy]>=IMax then
    IMax:=Int[ix,iy];
 cI:=255/Imax;

 for iy:=-ratio to ratio do
  for ix:=-ratio to ratio do
  begin
   grx:=ratio+ix;
   gry:=ratio+iy;
   c:=round(cI*Int[ix,iy]);
   Col:=rgb(c,c,c);
   Form1.Canvas.Pixels[grx,gry]:=Col;
  end;

  for j:=1 to maxn do
  begin
   grx:=ratio + round(A[j].X/scale);
   gry:=ratio + round(A[j].Y/scale);
   Form1.Canvas.Pen.Color:=rgb(255,0,0);
   Form1.Canvas.ellipse(grx-2,gry-2,grx+2,gry+2);
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
 A1,x1,y1,L1,dfi1:real;
 A2,x2,y2,L2,dfi2:real;
 x,y:real;
 dfi:real;
 Int,k:real;
 c:byte;
 Col:TColor;
 i,j:integer;
begin
 A1:=1;
 A2:=1;
 k:=2*pi/5;
 for i:=0 to 400 do
  for j:=0 to 400 do
  begin
   x:=c1*(i-200);
   y:=c1*(j-200);
   x1:=-50-x;
   y1:=-50-y;
   x2:=50-x;
   y2:=50-y;
   L1:=sqrt(x1*x1+y1*y1+L02);
   L2:=sqrt(x2*x2+y2*y2+L02);
   dfi1:=k*L1;
   dfi2:=k*L2;
   Int:=127*(A1*A1/2+A1*A2*cos(dfi2-dfi1)+ A2*A1/2);
   c:=round(Int);
   Col:=rgb(c,c,c);
   Canvas.Pixels[i,j]:=Col;
 end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
 InitData;
 Evaluate;
 Draw;
end;

end.
